Merge pull request #22912 from fiigii/fixBroadcast
[platform/upstream/coreclr.git] / build-test.sh
1 #!/usr/bin/env bash
2
3 __PortableBuild=1
4
5 initTargetDistroRid()
6 {
7     source init-distro-rid.sh
8
9     # Only pass ROOTFS_DIR if cross is specified.
10     if (( ${__CrossBuild} == 1 )); then
11         passedRootfsDir=${ROOTFS_DIR}
12     fi
13
14     initDistroRidGlobal ${__BuildOS} ${__BuildArch} ${__PortableBuild} ${passedRootfsDir}
15 }
16
17 isMSBuildOnNETCoreSupported()
18 {
19     __isMSBuildOnNETCoreSupported=$__msbuildonunsupportedplatform
20
21     if [ $__isMSBuildOnNETCoreSupported == 1 ]; then
22         return
23     fi
24
25     if [ "$__HostArch" == "x64" ]; then
26         if [ "$__HostOS" == "Linux" ]; then
27             __isMSBuildOnNETCoreSupported=1
28             UNSUPPORTED_RIDS=("debian.9-x64" "ubuntu.17.04-x64")
29             for UNSUPPORTED_RID in "${UNSUPPORTED_RIDS[@]}"
30             do
31                 if [ "${__DistroRid}" == "$UNSUPPORTED_RID" ]; then
32                     __isMSBuildOnNETCoreSupported=0
33                     break
34                 fi
35             done
36         elif [ "$__HostOS" == "OSX" ]; then
37             __isMSBuildOnNETCoreSupported=1
38         fi
39     fi
40 }
41
42 build_test_wrappers()
43 {
44     if [ $__BuildTestWrappers -ne -0 ]; then
45         echo "${__MsgPrefix}Creating test wrappers..."
46
47         export __Exclude="${__ProjectDir}/tests/issues.targets"
48         export __BuildLogRootName="Tests_XunitWrapper"
49
50         buildVerbosity="Summary"
51
52         if [ $__VerboseBuild == 1 ]; then
53             buildVerbosity="Diag"
54         fi
55
56         # Set up directories and file names
57         __BuildLogRootName=$subDirectoryName
58         __BuildLog="$__LogsDir/${__BuildLogRootName}.${__BuildOS}.${__BuildArch}.${__BuildType}.log"
59         __BuildWrn="$__LogsDir/${__BuildLogRootName}.${__BuildOS}.${__BuildArch}.${__BuildType}.wrn"
60         __BuildErr="$__LogsDir/${__BuildLogRootName}.${__BuildOS}.${__BuildArch}.${__BuildType}.err"
61         __MsbuildLog="/fileloggerparameters:\"Verbosity=normal;LogFile=${__BuildLog}\""
62         __MsbuildWrn="/fileloggerparameters1:\"WarningsOnly;LogFile=${__BuildWrn}\""
63         __MsbuildErr="/fileloggerparameters2:\"ErrorsOnly;LogFile=${__BuildErr}\""
64         __Logging="$__MsbuildLog $__MsbuildWrn $__MsbuildErr /consoleloggerparameters:$buildVerbosity"
65
66         nextCommand="\"${__DotNetCli}\" msbuild \"${__ProjectDir}/tests/runtest.proj\" /p:RestoreAdditionalProjectSources=https://dotnet.myget.org/F/dotnet-core/ /p:BuildWrappers=true /p:TargetsWindows=false $__Logging /p:__BuildOS=$__BuildOS /p:__BuildType=$__BuildType /p:__BuildArch=$__BuildArch"
67         eval $nextCommand
68
69         if [ $? -ne 0 ]; then
70             echo "${__MsgPrefix}Error: build failed. Refer to the build log files for details (above)"
71             exit 1
72         else
73             echo "XUnit Wrappers have been built."
74             echo { "\"build_os\"": "\"${__BuildOS}\"", "\"build_arch\"": "\"${__BuildArch}\"", "\"build_type\"": "\"${__BuildType}\"" } > "${__TestWorkingDir}/build_info.json"
75
76         fi
77     fi
78 }
79
80 generate_layout()
81 {
82     echo "${__MsgPrefix}Creating test overlay..."
83
84     __TestDir=$__ProjectDir/tests
85     __ProjectFilesDir=$__TestDir
86     __TestBinDir=$__TestWorkingDir
87
88     if [ $__RebuildTests -ne 0 ]; then
89         if [ -d "${__TestBinDir}" ]; then
90             echo "Removing tests build dir: ${__TestBinDir}"
91             rm -rf $__TestBinDir
92         fi
93     fi
94
95     __CMakeBinDir="${__TestBinDir}"
96
97     if [ -z "$__TestIntermediateDir" ]; then
98         __TestIntermediateDir="tests/obj/${__BuildOS}.${__BuildArch}.${__BuildType}"
99     fi
100
101     echo "__BuildOS: ${__BuildOS}"
102     echo "__BuildArch: ${__BuildArch}"
103     echo "__BuildType: ${__BuildType}"
104     echo "__TestIntermediateDir: ${__TestIntermediateDir}"
105
106     if [ ! -f "$__TestBinDir" ]; then
107         echo "Creating TestBinDir: ${__TestBinDir}"
108         mkdir -p $__TestBinDir
109     fi
110     if [ ! -f "$__LogsDir" ]; then
111         echo "Creating LogsDir: ${__LogsDir}"
112         mkdir -p $__LogsDir
113     fi
114     if [ ! -f "$__MsbuildDebugLogsDir" ]; then
115         echo "Creating MsbuildDebugLogsDir: ${__MsbuildDebugLogsDir}"
116         mkdir -p $__MsbuildDebugLogsDir
117     fi
118
119     # Set up the directory for MSBuild debug logs.
120     export MSBUILDDEBUGPATH="${__MsbuildDebugLogsDir}"
121
122     __BuildProperties="-p:OSGroup=${__BuildOS} -p:BuildOS=${__BuildOS} -p:BuildArch=${__BuildArch} -p:BuildType=${__BuildType}"
123
124     # =========================================================================================
125     # ===
126     # === Restore product binaries from packages
127     # ===
128     # =========================================================================================
129
130     build_MSBuild_projects "Restore_Packages" "${__ProjectDir}/tests/build.proj" "Restore product binaries (build tests)" "/t:BatchRestorePackages"
131
132     if [ -n "$__UpdateInvalidPackagesArg" ]; then
133         __up="/t:UpdateInvalidPackageVersions"
134     fi
135
136     echo "${__MsgPrefix}Creating test overlay..."
137
138     if [ -z "$xUnitTestBinBase" ]; then
139         xUnitTestBinBase=$__TestWorkingDir
140     fi
141
142     export CORE_ROOT=$xUnitTestBinBase/Tests/Core_Root
143
144     if [ -d "${CORE_ROOT}" ]; then
145         rm -rf $CORE_ROOT
146     fi
147
148     mkdir -p $CORE_ROOT
149
150     build_MSBuild_projects "Tests_Overlay_Managed" "${__ProjectDir}/tests/runtest.proj" "Creating test overlay" "/t:CreateTestOverlay"
151
152     chmod +x $__BinDir/corerun
153     chmod +x $__BinDir/crossgen
154
155     # Make sure to copy over the pulled down packages
156     cp -r $__BinDir/* $CORE_ROOT/ > /dev/null
157 }
158
159 generate_testhost()
160 {
161     echo "${__MsgPrefix}Generating test host..."
162
163     export TEST_HOST=$xUnitTestBinBase/testhost
164
165     if [ -d "${TEST_HOST}" ]; then
166         rm -rf $TEST_HOST
167     fi
168
169     mkdir -p $TEST_HOST
170
171     build_MSBuild_projects "Tests_Generate_TestHost" "${__ProjectDir}/tests/runtest.proj" "Creating test host" "/t:CreateTestHost"
172 }
173
174
175 build_Tests()
176 {
177     echo "${__MsgPrefix}Building Tests..."
178
179     __TestDir=$__ProjectDir/tests
180     __ProjectFilesDir=$__TestDir
181     __TestBinDir=$__TestWorkingDir
182
183     if [ -f  "${__TestWorkingDir}/build_info.json" ]; then
184         rm  "${__TestWorkingDir}/build_info.json"
185     fi
186
187     if [ $__RebuildTests -ne 0 ]; then
188         if [ -d "${__TestBinDir}" ]; then
189             echo "Removing tests build dir: ${__TestBinDir}"
190             rm -rf $__TestBinDir
191         fi
192     fi
193
194     export __CMakeBinDir="${__TestBinDir}"
195     if [ ! -d "${__TestIntermediatesDir}" ]; then
196         mkdir -p ${__TestIntermediatesDir}
197     fi
198
199     __NativeTestIntermediatesDir="${__TestIntermediatesDir}/Native"
200     if [  ! -d "${__NativeTestIntermediatesDir}" ]; then
201         mkdir -p ${__NativeTestIntermediatesDir}
202     fi
203
204     __ManagedTestIntermediatesDir="${__TestIntermediatesDir}/Managed"
205     if [ ! -d "${__ManagedTestIntermediatesDir}" ]; then
206         mkdir -p ${__ManagedTestIntermediatesDir}
207     fi
208
209     echo "__BuildOS: ${__BuildOS}"
210     echo "__BuildArch: ${__BuildArch}"
211     echo "__BuildType: ${__BuildType}"
212     echo "__TestIntermediatesDir: ${__TestIntermediatesDir}"
213     echo "__NativeTestIntermediatesDir: ${__NativeTestIntermediatesDir}"
214     echo "__ManagedTestIntermediatesDir: ${__ManagedTestIntermediatesDir}"
215
216     if [ ! -f "$__TestBinDir" ]; then
217         echo "Creating TestBinDir: ${__TestBinDir}"
218         mkdir -p $__TestBinDir
219     fi
220     if [ ! -f "$__LogsDir" ]; then
221         echo "Creating LogsDir: ${__LogsDir}"
222         mkdir -p $__LogsDir
223     fi
224     if [ ! -f "$__MsbuildDebugLogsDir" ]; then
225         echo "Creating MsbuildDebugLogsDir: ${__MsbuildDebugLogsDir}"
226         mkdir -p $__MsbuildDebugLogsDir
227     fi
228
229     # Set up the directory for MSBuild debug logs.
230     export MSBUILDDEBUGPATH="${__MsbuildDebugLogsDir}"
231
232     __BuildProperties="-p:OSGroup=${__BuildOS} -p:BuildOS=${__BuildOS} -p:BuildArch=${__BuildArch} -p:BuildType=${__BuildType}"
233
234     # =========================================================================================
235     # ===
236     # === Restore product binaries from packages
237     # ===
238     # =========================================================================================
239
240     if [ ${__SkipRestorePackages} != 1 ]; then
241         build_MSBuild_projects "Restore_Product" "${__ProjectDir}/tests/build.proj" "Restore product binaries (build tests)" "/t:BatchRestorePackages"
242     fi
243
244     if [ $__SkipNative != 1 ]; then
245         build_native_projects "$__BuildArch" "${__NativeTestIntermediatesDir}"
246
247         if [ $? -ne 0 ]; then
248             echo "${__MsgPrefix}Error: build failed. Refer to the build log files for details (above)"
249             exit 1
250         fi
251     fi
252
253     if [ $__SkipManaged != 1 ]; then
254         echo "Starting the Managed Tests Build..."
255
256         build_MSBuild_projects "Tests_Managed" "$__ProjectDir/tests/build.proj" "Managed tests build (build tests)" "$__up"
257
258         if [ $? -ne 0 ]; then
259             echo "${__MsgPrefix}Error: build failed. Refer to the build log files for details (above)"
260             exit 1
261         else
262             echo "Checking the Managed Tests Build..."
263
264             build_MSBuild_projects "Check_Test_Build" "${__ProjectDir}/tests/runtest.proj" "Check Test Build" "/t:CheckTestBuild"
265
266             if [ $? -ne 0 ]; then
267                 echo "${__MsgPrefix}Error: Check Test Build failed."
268                 exit 1
269             fi
270         fi
271
272         echo "Managed tests build success!"
273     fi
274
275     build_test_wrappers
276
277     if [ -n "$__UpdateInvalidPackagesArg" ]; then
278         __up="/t:UpdateInvalidPackageVersions"
279     fi
280
281     generate_layout
282 }
283
284 build_MSBuild_projects()
285 {
286     subDirectoryName=$1
287     shift
288     projectName=$1
289     shift
290     stepName="$1"
291     shift
292     extraBuildParameters=("$@")
293
294     # Set up directories and file names
295     __BuildLogRootName=$subDirectoryName
296     __BuildLog="$__LogsDir/${__BuildLogRootName}.${__BuildOS}.${__BuildArch}.${__BuildType}.log"
297     __BuildWrn="$__LogsDir/${__BuildLogRootName}.${__BuildOS}.${__BuildArch}.${__BuildType}.wrn"
298     __BuildErr="$__LogsDir/${__BuildLogRootName}.${__BuildOS}.${__BuildArch}.${__BuildType}.err"
299
300     # Use binclashlogger by default if no other logger is specified
301     if [[ "${extraBuildParameters[*]}" == *"/l:"* ]]; then
302         __msbuildEventLogging=
303     else
304         __msbuildEventLogging="/l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log"
305     fi
306
307     if [[ "$subDirectoryName" == "Tests_Managed" ]]; then
308         # Execute msbuild managed test build in stages - workaround for excessive data retention in MSBuild ConfigCache
309         # See https://github.com/Microsoft/msbuild/issues/2993
310
311         # __SkipPackageRestore and __SkipTargetingPackBuild used  to control build by tests/src/dirs.proj
312         export __SkipPackageRestore=false
313         export __SkipTargetingPackBuild=false
314         export __NumberOfTestGroups=3
315
316         __AppendToLog=false
317
318         if [ -n "$__priority1" ]; then
319             export __NumberOfTestGroups=10
320         fi
321
322         for (( testGroupToBuild=1 ; testGroupToBuild <= __NumberOfTestGroups; testGroupToBuild = testGroupToBuild + 1 ))
323         do
324             __msbuildLog="\"/flp:Verbosity=normal;LogFile=${__BuildLog};Append=${__AppendToLog}\""
325             __msbuildWrn="\"/flp1:WarningsOnly;LogFile=${__BuildWrn};Append=${__AppendToLog}\""
326             __msbuildErr="\"/flp2:ErrorsOnly;LogFile=${__BuildErr};Append=${__AppendToLog}\""
327
328             export __TestGroupToBuild=$testGroupToBuild
329
330             # Generate build command
331             buildArgs=("/nologo" "/verbosity:minimal" "/clp:Summary")
332             buildArgs+=("/p:RestoreDefaultOptimizationDataPackage=false" "/p:PortableBuild=true")
333             buildArgs+=("/p:UsePartialNGENOptimization=false" "/maxcpucount")
334
335             buildArgs+=("$projectName" "${__msbuildLog}" "${__msbuildWrn}" "${__msbuildErr}")
336             buildArgs+=("$__msbuildEventLogging")
337             buildArgs+=("${extraBuildParameters[@]}")
338             buildArgs+=("${__CommonMSBuildArgs[@]}")
339             buildArgs+=("${__UnprocessedBuildArgs[@]}")
340
341             nextCommand="\"$__ProjectRoot/dotnet.sh\" msbuild ${buildArgs[@]}"
342             echo "Building step '$stepName' testGroupToBuild=$testGroupToBuild via $nextCommand"
343             eval $nextCommand
344
345             # Make sure everything is OK
346             if [ $? -ne 0 ]; then
347                 echo "${__MsgPrefix}Failed to build $stepName. See the build logs:"
348                 echo "    $__BuildLog"
349                 echo "    $__BuildWrn"
350                 echo "    $__BuildErr"
351                 exit 1
352             fi
353             export __SkipPackageRestore=true
354             export __SkipTargetingPackBuild=true
355             __AppendToLog=true
356         done
357     else
358         __msbuildLog="\"/flp:Verbosity=normal;LogFile=${__BuildLog}\""
359         __msbuildWrn="\"/flp1:WarningsOnly;LogFile=${__BuildWrn}\""
360         __msbuildErr="\"/flp2:ErrorsOnly;LogFile=${__BuildErr}\""
361
362         # Generate build command
363         buildArgs=("/nologo" "/verbosity:minimal" "/clp:Summary")
364         buildArgs+=("/p:RestoreDefaultOptimizationDataPackage=false" "/p:PortableBuild=true")
365         buildArgs+=("/p:UsePartialNGENOptimization=false" "/maxcpucount")
366
367         buildArgs+=("$projectName" "${__msbuildLog}" "${__msbuildWrn}" "${__msbuildErr}")
368         buildArgs+=("$__msbuildEventLogging")
369         buildArgs+=("${extraBuildParameters[@]}")
370         buildArgs+=("${__CommonMSBuildArgs[@]}")
371         buildArgs+=("${__UnprocessedBuildArgs[@]}")
372
373         nextCommand="\"$__ProjectRoot/dotnet.sh\" msbuild ${buildArgs[@]}"
374         echo "Building step '$stepName' via $nextCommand"
375         eval $nextCommand
376
377         # Make sure everything is OK
378         if [ $? -ne 0 ]; then
379             echo "${__MsgPrefix}Failed to build $stepName. See the build logs:"
380             echo "    $__BuildLog"
381             echo "    $__BuildWrn"
382             echo "    $__BuildErr"
383             exit 1
384         fi
385     fi
386 }
387
388 build_native_projects()
389 {
390     platformArch="$1"
391     intermediatesForBuild="$2"
392
393     extraCmakeArguments="-DCLR_CMAKE_TARGET_OS=${__BuildOS} -DCLR_CMAKE_HOST_ARCH=${platformArch}"
394     message="native tests assets"
395
396     # All set to commence the build
397     echo "Commencing build of $message for $__BuildOS.$__BuildArch.$__BuildType in $intermediatesForBuild"
398
399     generator=""
400     buildFile="Makefile"
401     buildTool="make"
402     if [ $__UseNinja == 1 ]; then
403         generator="ninja"
404         buildFile="build.ninja"
405         if ! buildTool=$(command -v ninja || command -v ninja-build); then
406            echo "Unable to locate ninja!" 1>&2
407            exit 1
408         fi
409     fi
410
411     if [ $__SkipConfigure == 0 ]; then
412         # if msbuild is not supported, then set __SkipGenerateVersion to 1
413         if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipGenerateVersion=1; fi
414         # Drop version.c file
415         __versionSourceFile="$intermediatesForBuild/version.c"
416         if [ $__SkipGenerateVersion == 0 ]; then
417             pwd
418             $__ProjectRoot/dotnet.sh msbuild /nologo /verbosity:minimal /clp:Summary \
419                                      /p:RestoreDefaultOptimizationDataPackage=false /p:PortableBuild=true \
420                                      /p:UsePartialNGENOptimization=false /maxcpucount \
421                                      $__ProjectDir/build.proj /t:GenerateVersionHeader \
422                                      /p:GenerateVersionHeader=true /p:NativeVersionSourceFile=$__versionSourceFile \
423                                      /l:BinClashLogger,Tools/Microsoft.DotNet.Build.Tasks.dll\;LogFile=binclash.log \
424                                      $__CommonMSBuildArgs $__UnprocessedBuildArgs
425         else
426             # Generate the dummy version.c, but only if it didn't exist to make sure we don't trigger unnecessary rebuild
427             __versionSourceLine="static char sccsid[] __attribute__((used)) = \"@(#)No version information produced\";"
428             if [ -e $__versionSourceFile ]; then
429                 read existingVersionSourceLine < $__versionSourceFile
430             fi
431             if [ "$__versionSourceLine" != "$existingVersionSourceLine" ]; then
432                 echo $__versionSourceLine > $__versionSourceFile
433             fi
434         fi
435
436         pushd "$intermediatesForBuild"
437         # Regenerate the CMake solution
438         # Force cross dir to point to project root cross dir, in case there is a cross build.
439         nextCommand="CONFIG_DIR=\"$__ProjectRoot/cross\" \"$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh\" \"$__TestDir\" $__ClangMajorVersion $__ClangMinorVersion $platformArch $__BuildType $__CodeCoverage $generator $extraCmakeArguments $__cmakeargs"
440         echo "Invoking $nextCommand"
441         eval $nextCommand
442         popd
443     fi
444
445     if [ ! -f "$intermediatesForBuild/$buildFile" ]; then
446         echo "Failed to generate $message build project!"
447         exit 1
448     fi
449
450     # Build
451     if [ $__ConfigureOnly == 1 ]; then
452         echo "Finish configuration & skipping $message build."
453         return
454     fi
455
456     pushd "$intermediatesForBuild"
457
458     echo "Executing $buildTool install -j $__NumProc"
459
460     $buildTool install -j $__NumProc
461     if [ $? != 0 ]; then
462         echo "Failed to build $message."
463         exit 1
464     fi
465
466     popd
467     echo "Native tests build success!"
468 }
469
470 usage()
471 {
472     echo "Usage: $0 [BuildArch] [BuildType] [verbose] [coverage] [cross] [clangx.y] [ninja] [runtests] [bindir]"
473     echo "BuildArch can be: x64, x86, arm, armel, arm64"
474     echo "BuildType can be: debug, checked, release"
475     echo "coverage - optional argument to enable code coverage build (currently supported only for Linux and OSX)."
476     echo "ninja - target ninja instead of GNU make"
477     echo "clangx.y - optional argument to build using clang version x.y - supported version 3.5 - 6.0"
478     echo "cross - optional argument to signify cross compilation,"
479     echo "      - will use ROOTFS_DIR environment variable if set."
480     echo "portableLinux - build for Portable Linux Distribution"
481     echo "portablebuild - Use portable build."
482     echo "verbose - optional argument to enable verbose build output."
483     echo "rebuild - if tests have already been built - rebuild them"
484     echo "skipnative: skip the native tests build"
485     echo "skipmanaged: skip the managed section of the test build"
486     echo "buildtestwrappersonly - only build the test wrappers"
487     echo "generatelayoutonly - only pull down dependencies and build coreroot"
488     echo "generatetesthostonly - only pull down dependencies and build coreroot and the CoreFX testhost"
489     echo "skiprestorepackages - skip package restore"
490     echo "runtests - run tests after building them"
491     echo "bindir - output directory (defaults to $__ProjectRoot/bin)"
492     echo "msbuildonunsupportedplatform - build managed binaries even if distro is not officially supported."
493     echo "priority1 - include priority=1 tests in the build"
494     exit 1
495 }
496
497
498 # Obtain the location of the bash script to figure out where the root of the repo is.
499 __ProjectRoot="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
500
501 # Use uname to determine what the CPU is.
502 CPUName=$(uname -p)
503
504 # Some Linux platforms report unknown for platform, but the arch for machine.
505 if [ "$CPUName" == "unknown" ]; then
506     CPUName=$(uname -m)
507 fi
508
509 case $CPUName in
510     i686)
511         echo "Unsupported CPU $CPUName detected, build might not succeed!"
512         __BuildArch=x86
513         __HostArch=x86
514         ;;
515
516     x86_64)
517         __BuildArch=x64
518         __HostArch=x64
519         ;;
520
521     armv7l)
522         echo "Unsupported CPU $CPUName detected, build might not succeed!"
523         __BuildArch=arm
524         __HostArch=arm
525         ;;
526
527     aarch64)
528         __BuildArch=arm64
529         __HostArch=arm64
530         ;;
531
532     *)
533         echo "Unknown CPU $CPUName detected, configuring as if for x64"
534         __BuildArch=x64
535         __HostArch=x64
536         ;;
537 esac
538
539 # Use uname to determine what the OS is.
540 OSName=$(uname -s)
541 case $OSName in
542     Linux)
543         __BuildOS=Linux
544         __HostOS=Linux
545         ;;
546
547     Darwin)
548         __BuildOS=OSX
549         __HostOS=OSX
550         ;;
551
552     FreeBSD)
553         __BuildOS=FreeBSD
554         __HostOS=FreeBSD
555         ;;
556
557     OpenBSD)
558         __BuildOS=OpenBSD
559         __HostOS=OpenBSD
560         ;;
561
562     NetBSD)
563         __BuildOS=NetBSD
564         __HostOS=NetBSD
565         ;;
566
567     SunOS)
568         __BuildOS=SunOS
569         __HostOS=SunOS
570         ;;
571
572     *)
573         echo "Unsupported OS $OSName detected, configuring as if for Linux"
574         __BuildOS=Linux
575         __HostOS=Linux
576         ;;
577 esac
578
579 __BuildType=Debug
580 __CodeCoverage=
581 __IncludeTests=INCLUDE_TESTS
582
583 # Set the various build properties here so that CMake and MSBuild can pick them up
584 export __ProjectDir="$__ProjectRoot"
585 __SourceDir="$__ProjectDir/src"
586 __PackagesDir="$__ProjectDir/packages"
587 __RootBinDir="$__ProjectDir/bin"
588 __BuildToolsDir="$__ProjectDir/Tools"
589 __DotNetCli="$__ProjectDir/dotnet.sh"
590 __UnprocessedBuildArgs=
591 __CommonMSBuildArgs=
592 __MSBCleanBuildArgs=
593 __UseNinja=0
594 __VerboseBuild=0
595 __SkipRestore=""
596 __SkipNative=0
597 __SkipManaged=0
598 __SkipConfigure=0
599 __SkipGenerateVersion=0
600 __ConfigureOnly=0
601 __CrossBuild=0
602 __ClangMajorVersion=0
603 __ClangMinorVersion=0
604 __NuGetPath="$__PackagesDir/NuGet.exe"
605 __SkipRestorePackages=0
606 __DistroRid=""
607 __cmakeargs=""
608 __PortableLinux=0
609 __msbuildonunsupportedplatform=0
610 __NativeTestIntermediatesDir=
611 __RunTests=0
612 __RebuildTests=0
613 __BuildTestWrappers=1
614 __GenerateLayoutOnly=
615 __GenerateTestHostOnly=
616 __priority1=
617 __BuildTestWrappersOnly=
618 CORE_ROOT=
619
620 while :; do
621     if [ $# -le 0 ]; then
622         break
623     fi
624
625     lowerI="$(echo $1 | awk '{print tolower($0)}')"
626     case $lowerI in
627         -\?|-h|--help)
628             usage
629             exit 1
630             ;;
631
632         x86)
633             __BuildArch=x86
634             ;;
635
636         x64)
637             __BuildArch=x64
638             ;;
639
640         arm)
641             __BuildArch=arm
642             ;;
643
644         armel)
645             __BuildArch=armel
646             ;;
647
648         arm64)
649             __BuildArch=arm64
650             ;;
651
652         debug)
653             __BuildType=Debug
654             ;;
655
656         checked)
657             __BuildType=Checked
658             ;;
659
660         release)
661             __BuildType=Release
662             ;;
663
664         coverage)
665             __CodeCoverage=Coverage
666             ;;
667
668         cross)
669             __CrossBuild=1
670             ;;
671
672         portablebuild=false)
673             __PortableBuild=0
674             ;;
675
676         portablelinux)
677             if [ "$__BuildOS" == "Linux" ]; then
678                 __PortableLinux=1
679             else
680                 echo "ERROR: portableLinux not supported for non-Linux platforms."
681                 exit 1
682             fi
683             ;;
684
685         verbose)
686             __VerboseBuild=1
687             ;;
688
689         clang3.5|-clang3.5)
690             __ClangMajorVersion=3
691             __ClangMinorVersion=5
692             ;;
693
694         clang3.6|-clang3.6)
695             __ClangMajorVersion=3
696             __ClangMinorVersion=6
697             ;;
698
699         clang3.7|-clang3.7)
700             __ClangMajorVersion=3
701             __ClangMinorVersion=7
702             ;;
703
704         clang3.8|-clang3.8)
705             __ClangMajorVersion=3
706             __ClangMinorVersion=8
707             ;;
708
709         clang3.9|-clang3.9)
710             __ClangMajorVersion=3
711             __ClangMinorVersion=9
712             ;;
713
714         clang4.0|-clang4.0)
715             __ClangMajorVersion=4
716             __ClangMinorVersion=0
717             ;;
718
719         clang5.0|-clang5.0)
720             __ClangMajorVersion=5
721             __ClangMinorVersion=0
722             ;;
723
724         clang6.0|-clang6.0)
725             __ClangMajorVersion=6
726             __ClangMinorVersion=0
727             ;;
728
729         ninja)
730             __UseNinja=1
731             ;;
732
733         runtests)
734             __RunTests=1
735             ;;
736
737         rebuild)
738             __RebuildTests=1
739             ;;
740
741         skipnative|-skipnative)
742             __SkipNative=1
743             ;;
744
745         skipmanaged|-skipmanaged)
746             __SkipManaged=1
747             __BuildTestWrappers=0
748             ;;
749
750         buildtestwrappersonly)
751             __BuildTestWrappersOnly=1
752             ;;
753
754         generatelayoutonly)
755             __GenerateLayoutOnly=1
756             ;;
757
758         generatetesthostonly)
759             __GenerateTestHostOnly=1
760             ;;
761
762         skiprestorepackages)
763             __SkipRestorePackages=1
764             ;;
765
766         bindir)
767             if [ -n "$2" ]; then
768                 __RootBinDir="$2"
769                 if [ ! -d $__RootBinDir ]; then
770                     mkdir $__RootBinDir
771                 fi
772                 __RootBinParent=$(dirname $__RootBinDir)
773                 __RootBinName=${__RootBinDir##*/}
774                 __RootBinDir="$(cd $__RootBinParent &>/dev/null && printf %s/%s $PWD $__RootBinName)"
775                 shift
776             else
777                 echo "ERROR: 'bindir' requires a non-empty option argument"
778                 exit 1
779             fi
780             ;;
781
782         msbuildonunsupportedplatform)
783             __msbuildonunsupportedplatform=1
784             ;;
785
786         priority1)
787             __priority1=1
788             __UnprocessedBuildArgs+=("/p:CLRTestPriorityToBuild=1")
789             ;;
790
791         *)
792             __UnprocessedBuildArgs+=("$1")
793             ;;
794     esac
795
796     shift
797 done
798
799 # Get the number of processors available to the scheduler
800 # Other techniques such as `nproc` only get the number of
801 # processors available to a single process.
802 if [ `uname` = "FreeBSD" ]; then
803   __NumProc=`sysctl hw.ncpu | awk '{ print $2+1 }'`
804 elif [ `uname` = "NetBSD" ]; then
805   __NumProc=$(($(getconf NPROCESSORS_ONLN)+1))
806 elif [ `uname` = "Darwin" ]; then
807   __NumProc=$(($(getconf _NPROCESSORS_ONLN)+1))
808 else
809   __NumProc=$(nproc --all)
810 fi
811
812 __CommonMSBuildArgs=("/p:__BuildArch=$__BuildArch" "/p:__BuildType=$__BuildType" "/p:__BuildOS=$__BuildOS")
813
814 # Configure environment if we are doing a verbose build
815 if [ $__VerboseBuild == 1 ]; then
816     export VERBOSE=1
817     __CommonMSBuildArgs+=("/v:detailed")
818 fi
819
820 # Set default clang version
821 if [[ $__ClangMajorVersion == 0 && $__ClangMinorVersion == 0 ]]; then
822     if [[ "$__BuildArch" == "arm" || "$__BuildArch" == "armel" ]]; then
823         __ClangMajorVersion=5
824         __ClangMinorVersion=0
825     else
826         __ClangMajorVersion=3
827         __ClangMinorVersion=9
828     fi
829 fi
830
831 # Set dependent variables
832 __LogsDir="$__RootBinDir/Logs"
833 __MsbuildDebugLogsDir="$__LogsDir/MsbuildDebugLogs"
834
835 # Set the remaining variables based upon the determined build configuration
836 __BinDir="$__RootBinDir/Product/$__BuildOS.$__BuildArch.$__BuildType"
837 __PackagesBinDir="$__BinDir/.nuget"
838 __TestDir="$__ProjectDir/tests"
839 __TestWorkingDir="$__RootBinDir/tests/$__BuildOS.$__BuildArch.$__BuildType"
840 __IntermediatesDir="$__RootBinDir/obj/$__BuildOS.$__BuildArch.$__BuildType"
841 __TestIntermediatesDir="$__RootBinDir/tests/obj/$__BuildOS.$__BuildArch.$__BuildType"
842 __isMSBuildOnNETCoreSupported=0
843 __CrossComponentBinDir="$__BinDir"
844 __CrossCompIntermediatesDir="$__IntermediatesDir/crossgen"
845
846 __CrossArch="$__HostArch"
847 if [[ "$__HostArch" == "x64" && "$__BuildArch" == "arm" ]]; then
848     __CrossArch="x86"
849 fi
850 if [ $__CrossBuild == 1 ]; then
851     __CrossComponentBinDir="$__CrossComponentBinDir/$__CrossArch"
852 fi
853 __CrossgenCoreLibLog="$__LogsDir/CrossgenCoreLib_$__BuildOS.$BuildArch.$__BuildType.log"
854 __CrossgenExe="$__CrossComponentBinDir/crossgen"
855
856 isMSBuildOnNETCoreSupported
857
858 # CI_SPECIFIC - On CI machines, $HOME may not be set. In such a case, create a subfolder and set the variable to it.
859 # This is needed by CLI to function.
860 if [ -z "$HOME" ]; then
861     if [ ! -d "$__ProjectDir/temp_home" ]; then
862         mkdir temp_home
863     fi
864     export HOME=$__ProjectDir/temp_home
865     echo "HOME not defined; setting it to $HOME"
866 fi
867
868 # Configure environment if we are doing a cross compile.
869 if [ $__CrossBuild == 1 ]; then
870     export CROSSCOMPILE=1
871     if ! [[ -n "$ROOTFS_DIR" ]]; then
872         export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__BuildArch"
873     fi
874 fi
875
876 # init the target distro name
877 initTargetDistroRid
878
879 # Override tool directory
880
881 if [[ (-z "$__GenerateLayoutOnly") && (-z "$__GenerateTestHostOnly") && (-z "$__BuildTestWrappersOnly") ]]; then
882     build_Tests
883 elif [ ! -z "$__BuildTestWrappersOnly" ]; then
884     build_test_wrappers
885 else
886     generate_layout
887     if [ ! -z "$__GenerateTestHostOnly" ]; then
888         generate_testhost
889     fi
890 fi
891
892 if [ $? -ne 0 ]; then
893     echo "Failed to build tests"
894     exit 1
895 fi
896
897 echo "${__MsgPrefix}Test build successful."
898 echo "${__MsgPrefix}Test binaries are available at ${__TestBinDir}"
899
900 __testNativeBinDir=$__IntermediatesDir/tests
901
902 if [ $__RunTests -ne 0 ]; then
903
904     echo "Run Tests..."
905
906     nextCommand="$__TestDir/runtest.sh --testRootDir=$__TestBinDir --coreClrBinDir=$__BinDir --coreFxBinDir=$CORE_ROOT --testNativeBinDir=$__testNativeBinDir"
907     echo "$nextCommand"
908     eval $nextCommand
909
910     echo "Tests run successful."
911 else
912     echo "To run all tests use 'tests/runtests.sh' where:"
913     echo "    testRootDir      = $__TestBinDir"
914     echo "    coreClrBinDir    = $__BinDir"
915     echo "    coreFxBinDir     = $CORE_ROOT"
916     echo "    testNativeBinDir = $__testNativeBinDir"
917     echo " -------------------------------------------------- "
918     echo " Example runtest.sh command"
919     echo ""
920     echo " ./tests/runtest.sh --coreOverlayDir=$CORE_ROOT --testNativeBinDir=$__testNativeBinDir --testRootDir=$__TestBinDir --copyNativeTestBin"
921     echo " -------------------------------------------------- "
922     echo "To run single test use the following command:"
923     echo "    bash ${__TestBinDir}/__TEST_PATH__/__TEST_NAME__.sh -coreroot=${CORE_ROOT}"
924 fi
925